<?php
$p_url = 'tools.php?p=referers';

/* Chargement des referers
-------------------------------------------------------- */

$reffilename = 'reffichier.html';
$blacklistfilename = 'refblacklist.html';
$referants = dirname(__FILE__) . '/' . $reffilename;
$blacklist = dirname(__FILE__) . '/' . $blacklistfilename;
$err = '';

if (!file_exists($referants)) {
	$err = '<p>' . sprintf(__('Referers file %s does not exist.'), "<strong>$referants</strong>") . '</p>';
} else if (!is_writable($referants)) {
	$err = '<p>'.sprintf(__('Referers file %s is not writable.'),"<strong>./$reffilename</strong>").'</p>';
}

$bl_writable = true;
if (!file_exists($blacklist)) {
	$err = '<p>'.sprintf(__('Black list file %s does not exist.'), "<strong>./$blacklistfilename</strong>").'</p>';
} else if (!is_writable($blacklist)) {
	$err = '<p>'.sprintf(__('Black list file %s is not writable.'),"<strong>./$blacklistfilename</strong>").'</p>';
  $bl_writable = false;
}

/* Sauvegarde du fichier black list
-------------------------------------------------------- */
if (!empty($_POST['f_content']) && $bl_writable) {
		$f_content = str_replace("\r",'',$_POST['f_content']);
		if (files::putContent($blacklist, $f_content) !== false)	{
			header('Location: '.$p_url);
			exit;
		} else {
			$err = '<p>'.__('Cannot write file.').'</p>';
		}
}


/* Affichage
-------------------------------------------------------- */
buffer::str('<h2>'.__('Referers').'</h2>');

if($err != '')
{
	buffer::str('<div class="erreur"><p><strong>'.__('Error(s)').' </strong></p>'.$err.'</div>');
}

buffer::str('<h3>' . 
__('Usage') . '</h3><p><ol><li>' . __('Add a call to the function') . ' <samp>dcReferers::displayReferers()</samp> ' . __('where you want your referers to be displayed in your template file.') .
'</li><li>' . __('By default, it displays only the last five referers. If you wish to display more referers, you can pass the number as a parameter to the function.') . '</li></ol></p>');

buffer::str('<h3>' . __('Black list') . '</h3><p>' . __('This black list works on the URL of the referers. The black list system uses regexps for matching, so you can take advantage of that if you wish. One entry per line only.') . '</p>');

if ($bl_writable) {
buffer::str('<form action="tools.php" method="post">' . 
	'<textarea id="f_content" name="f_content" rows="10" cols="60" style="width:100%;font-family:courier,monospace;">' .
  htmlspecialchars(@file_get_contents($blacklist)) . '</textarea>' .
  '<p><input type="submit" class="submit" value="' . __('save') . '" />' .
  '<input type="hidden" name="p" value="referers" /></p></form>');
} else {
buffer::str('<form action="tools.php" method="post">' . 
	'<textarea id="f_content" name="f_content" rows="10" cols="60" style="width:100%;font-family:courier,monospace;" readonly="readonly">' .
  htmlspecialchars(@file_get_contents($blacklist)) . '</textarea>' .
  '<p><input type="hidden" name="p" value="referers" /></p></form>');
}


buffer::str('<h3>' . __('Last Referers') . '</h3>');

buffer::str('<table border="1"><thead><tr><th>' . __('Displayed') . '</th><th>' . __('Full referer') . '</th></tr></thead>');
if (file_exists($referants)) {
	$refarray = file($referants);
	$refreverse = array_reverse($refarray);
	$refunique = array_unique($refreverse);
	$refcount = count($refunique);

	if ($refcount > 0) {
		buffer::str('<tbody>');
		for ($i = 0; $i < 10; $i++) {
			if ($i >= $refcount) { break; }
			if (preg_match('!href="([^ ]+)">([^ ]+)</a>!', array_shift($refunique), $refs)) {
				buffer::str('<tr><td>' . $refs[2] . '</td><td>' . $refs[1] . '</td></tr>');
			}
		}
		buffer::str('</tbody>');
	}
}
buffer::str('</table>');
buffer::str('<p>' . __('Note: this list is not filtered by the black list.') . '</p>');

buffer::str('<div class="copyright"><h3>' . __('Copyright information') . '</h3><p>' . 
sprintf(__('Based on code by %s and %s; plugin created by %s.'), '<a href="http://blog.lucas3d.com/">Lucas Janin</a>', 'Xavier Borderie', '<a href="http://www.mudry.org/">Julien Mudry</a>') . '</p></div>');

buffer::str('<div class="changelog"><h3>' . __('Changelog') . '</h3><h4>' . 
__('Version 0.5') . '</h4><ul><li>' . __('Added the protocols https, ftp and news for correct treatment of referers coming from those protocols.') . '</li></ul><h4>' . 
__('Version 0.4') . '</h4><ul><li>' . __('Changed extension of text files to html, hoping to solve one bug with Free.') . '</li></ul><h4>' . 
__('Version 0.3') . '</h4><ul><li>' . __('Black list filtering was added.') . '</li></ul><h4>' .
__('Version 0.2') . '</h4><ul><li>' . __('Correct order and number of referers.') . '</li><li>' . 
__('Use of htmlentities to store URLs.') . '</li><li>' . 
__('More correct copyright information.') . '</li></ul><h4>' .
__('Version 0.1') . '</h4><ul><li>' . __('First public version.') . '</li></ul>');
?>
